package com.qmth.teachcloud.common.bean.params;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.teachcloud.common.enums.ExceptionResultEnum;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.util.CollectionUtils;

import java.io.Serializable;
import java.util.List;
import java.util.Optional;

/**
 * @Description: 分析参数
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2022/5/27
 */
public class CalculateParams implements Serializable {

    @ApiModelProperty(value = "考试id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long examId;

    @ApiModelProperty(value = "课程编码，一个分析试卷的唯一标识")
    private List courseCode;

    /**
     * 参数校验
     */
    public void validParams() {
        Optional.ofNullable(this.getExamId()).orElseThrow(() -> ExceptionResultEnum.PARAMS_ERROR.exception("考试id为空"));
        if (CollectionUtils.isEmpty(courseCode)) {
            throw ExceptionResultEnum.PARAMS_ERROR.exception("课程编码为空");
        }
    }

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public List getCourseCode() {
        return courseCode;
    }

    public void setCourseCode(List courseCode) {
        this.courseCode = courseCode;
    }
}
