package com.qmth.teachcloud.common.sync.strategy;

import com.qmth.teachcloud.common.bean.params.CalculateParams;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public abstract class CalculateTaskTemplate {
    private final static Logger log = LoggerFactory.getLogger(CalculateTaskTemplate.class);
//    private static RedisUtil redisUtil = SpringContextHolder.getBean(RedisUtil.class);

    protected void createSyncTask() {
        log.info("createSyncTask come in");
    }

    protected abstract void dataVaild();

    protected abstract void calculate();

    protected void finished() {
        log.info("finished come in");
    }

    protected void exception() {
        log.info("exception come in");
    }

    public void start(CalculateParams calculateParams) {
        createSyncTask();
        dataVaild();
        calculate();
        finished();
    }
}

